diff -ruN vdr-1.5.6/i18n-to-gettext.pl vdr-1.5.7/i18n-to-gettext.pl
--- vdr-1.5.6/i18n-to-gettext.pl	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.5.7/i18n-to-gettext.pl	2007-08-12 12:02:01.000000000 +0200
@@ -0,0 +1,332 @@
+#!/usr/bin/perl -w
+
+# Convert i18n texts to gettext
+#
+# Extracts all texts from the file i18n.c and creates language
+# specific *.po files.
+#
+# Usage: i18n-to-gettext.pl
+#
+# See the main source file 'vdr.c' for copyright information and
+# how to reach the author.
+#
+# $Id: i18n-to-gettext.pl 1.2 2007/08/12 10:02:01 kls Exp $
+
+# How to convert an actual plugin:
+#
+# - If your code contains something like
+#
+#   const char *Text = "Some text";
+#   ...
+#   Function(tr(Text));
+#
+#   you need to enclose the text constant in trNOOP(...), as in
+#
+#   const char *Text = trNOOP("Some text");
+#
+#   The actual usage of the tr() macro remains unchanged.
+#
+# - If you have comments following the texts in your i18n.c file
+#   that should be seen by the translators, move them from the
+#   i18n.c file into the file where the text is actually used,
+#   and mark them with the TRANSLATORS keyword, as in
+#
+#   // TRANSLATORS: note the plural!
+#   Add(new cMenuEditIntItem( tr("Setup.EPG$Preferred languages"), ...
+#
+# - Fill in your email address in the line
+#   $MSGIDBUGS = "" ...
+#   below, so that users can reach you in case there is a problem
+#   with a message id.
+#
+# - Run this Perl script from within your plugin's source directory.
+#   This script will run 'xgettext' to extract all of your texts
+#   into a file named <pluginname>.pot. After that it will extract
+#   your existing i18n texts from the file i18n.c (or wherever you
+#   have defined them) and generate *.po files for all languages
+#   currently known by VDR.
+#
+# - Your Makefile will be automatically adjusted to allow for
+#   building the *.mo files necessary for supporting gettext().
+#   Please check carefully whether the automatic adjustments have
+#   succeeded, though. The modified Makefile will be written to
+#   Makefile.new, so you can call this script any numer of times
+#   in case you need to do some fine tuning of your texts (especially
+#   adding some trNOOP() in case the script reports "missing phrases".
+#   Once you're done converting your plugin source to using gettext,
+#   rename Makefile.new to Makefile.
+#
+# - You may want to remove the old internationalized texts from your
+#   source. Usually this means removing the files i18n.[hc], stripping
+#   i18n.o from the OBJS variable in the Makefile and removing all
+#   '#include "i18n.h"' lines from the rest of your source files.
+#   These steps are not done automatically.
+
+# Check for the existence of a Makefile:
+
+die "Makefile not found!" unless (-f "Makefile");
+
+# Determine the plugin name:
+
+$PLUGIN = `grep '^PLUGIN *=' Makefile | head -1` || die "can't find plugin name!";
+$PLUGIN =~ s/.*= *(.*)\n/$1/;
+die "can't find plugin name!" unless ($PLUGIN);
+
+# Locate the file containing the texts:
+
+$I18NFILE = "";
+for ("i18n.c", `ls *.c`) { # try i18n.c explicitly first
+    chomp($f = $_);
+    if (-f $f && `grep tI18nPhrase $f`) {
+       $I18NFILE = $f;
+       last;
+       }
+    }
+die "can't find internationalized texts!" unless ($I18NFILE);
+
+# Plugin specific information:
+
+$TITLE = "VDR plugin language source file";
+$COPYRIGHT = "2007 Klaus Schmidinger <kls\@cadsoft.de>";
+$PACKAGE = "VDR";
+$VERSION = "1.5.7";
+$MSGIDBUGS = "" || die "enter your email address here"; # escape the '@', as in "user\@domain.tld"
+$LANGUAGETEAM = "<vdr\@linuxtv.org>";
+
+# Gettext environment:
+
+$XGETTEXT = "xgettext -C -cTRANSLATORS --no-wrap -F -k -ktr -ktrNOOP --msgid-bugs-address='$MSGIDBUGS'";
+$PODIR = "po";
+$POTFILE = "$PODIR/$PLUGIN.pot";
+
+# Languages as known by VDR 1.5.6:
+
+@LANGS = (
+  "en_US",
+  "de_DE",
+  "sl_SI",
+  "it_IT",
+  "nl_NL",
+  "pt_PT",
+  "fr_FR",
+  "nn_NO",
+  "fi_FI",
+  "pl_PL",
+  "es_ES",
+  "el_GR",
+  "sv_SE",
+  "ro_RO",
+  "hu_HU",
+  "ca_ES",
+  "ru_RU",
+  "hr_HR",
+  "et_EE",
+  "da_DK",
+  "cs_CZ",
+  "tr_TR"
+  );
+
+@CHARSETS = (
+  "ISO-8859-15",
+  "ISO-8859-15",
+  "ISO-8859-2",
+  "ISO-8859-15",
+  "ISO-8859-15",
+  "ISO-8859-1",
+  "ISO-8859-1",
+  "ISO-8859-1",
+  "ISO-8859-15",
+  "ISO-8859-2",
+  "ISO-8859-15",
+  "ISO-8859-7",
+  "ISO-8859-1",
+  "ISO-8859-2",
+  "ISO-8859-2",
+  "ISO-8859-1",
+  "ISO-8859-5",
+  "ISO-8859-2",
+  "ISO-8859-13",
+  "ISO-8859-15",
+  "ISO-8859-2",
+  "ISO-8859-9",
+  );
+
+@TRANSLATORS = (
+  "Klaus Schmidinger <kls\@cadsoft.de>, 2000",
+  "Klaus Schmidinger <kls\@cadsoft.de>, 2000",
+  "Miha Setina <mihasetina\@softhome.net>, 2000; Matjaz Thaler <matjaz.thaler\@guest.arnes.si>, 2003",
+  "Alberto Carraro <bertocar\@tin.it>, 2001; Antonio Ospite <ospite\@studenti.unina.it>, 2003; Sean Carlos <seanc\@libero.it>, 2005",
+  "Arnold Niessen <niessen\@iae.nl> <arnold.niessen\@philips.com>, 2001; Hans Dingemans <hans.dingemans\@tacticalops.nl>, 2003; Maarten Wisse <Maarten.Wisse\@urz.uni-hd.de>, 2005",
+  "Paulo Lopes <pmml\@netvita.pt>, 2001",
+  "Jean-Claude Repetto <jc\@repetto.org>, 2001; Olivier Jacques <jacquesolivier\@hotmail.com>, 2003; Gregoire Favre <greg\@magma.unil.ch>, 2003; Nicolas Huillard <nhuillard\@e-dition.fr>, 2005",
+  "Jørgen Tvedt <pjtvedt\@online.no>, 2001; Truls Slevigen <truls\@slevigen.no>, 2002",
+  "Hannu Savolainen <hannu\@opensound.com>, 2002; Jaakko Hyvätti <jaakko\@hyvatti.iki.fi>, 2002; Niko Tarnanen <niko.tarnanen\@hut.fi>, 2003; Rolf Ahrenberg <rahrenbe\@cc.hut.fi>, 2003",
+  "Michael Rakowski <mrak\@gmx.de>, 2002",
+  "Ruben Nunez Francisco <ruben.nunez\@tang-it.com>, 2002",
+  "Dimitrios Dimitrakos <mail\@dimitrios.de>, 2002",
+  "Tomas Prybil <tomas\@prybil.se>, 2002; Jan Ekholm <chakie\@infa.abo.fi>, 2003",
+  "Paul Lacatus <paul\@campina.iiruc.ro>, 2002; Lucian Muresan <lucianm\@users.sourceforge.net>, 2004",
+  "Istvan Koenigsberger <istvnko\@hotmail.com>, 2002; Guido Josten <guido.josten\@t-online.de>, 2002",
+  "Marc Rovira Vall <tm05462\@salleURL.edu>, 2003; Ramon Roca <ramon.roca\@xcombo.com>, 2003; Jordi Vilà <jvila\@tinet.org>, 2003",
+  "Vyacheslav Dikonov <sdiconov\@mail.ru>, 2004",
+  "Drazen Dupor <drazen.dupor\@dupor.com>, 2004; Dino Ravnic <dino.ravnic\@fer.hr>, 2004",
+  "Arthur Konovalov <kasjas\@hot.ee>, 2004",
+  "Mogens Elneff <mogens\@elneff.dk>, 2004",
+  "Vladimír Bárta <vladimir.barta\@k2atmitec.cz>, 2006",
+  "Oktay Yolgeçen <oktay_73\@yahoo.de>, 2007"
+  );
+
+@LASTTRANSLATOR = (
+  "Klaus Schmidinger <kls\@cadsoft.de>",
+  "Klaus Schmidinger <kls\@cadsoft.de>",
+  "Matjaz Thaler <matjaz.thaler\@guest.arnes.si>",
+  "Sean Carlos <seanc\@libero.it>",
+  "Maarten Wisse <Maarten.Wisse\@urz.uni-hd.de>",
+  "Paulo Lopes <pmml\@netvita.pt>",
+  "Nicolas Huillard <nhuillard\@e-dition.fr>",
+  "Truls Slevigen <truls\@slevigen.no>",
+  "Rolf Ahrenberg <rahrenbe\@cc.hut.fi>",
+  "Michael Rakowski <mrak\@gmx.de>",
+  "Ruben Nunez Francisco <ruben.nunez\@tang-it.com>",
+  "Dimitrios Dimitrakos <mail\@dimitrios.de>",
+  "Tomas Prybil <tomas\@prybil.se>",
+  "Lucian Muresan <lucianm\@users.sourceforge.net>",
+  "Istvan Koenigsberger <istvnko\@hotmail.com>, Guido Josten <guido.josten\@t-online.de>",
+  "Jordi Vilà <jvila\@tinet.org>",
+  "Vyacheslav Dikonov <sdiconov\@mail.ru>",
+  "Drazen Dupor <drazen.dupor\@dupor.com>",
+  "Arthur Konovalov <kasjas\@hot.ee>",
+  "Mogens Elneff <mogens\@elneff.dk>",
+  "Vladimír Bárta <vladimir.barta\@k2atmitec.cz>",
+  "Oktay Yolgeçen <oktay_73\@yahoo.de>"
+  );
+
+# Collect all translated texts:
+
+open(F, $I18NFILE) || die "$I18NFILE: $!\n";
+while (<F>) {
+      chomp;
+      s/\t/ /g; # get rid of tabs
+      s/  *$//; # get rid of trailing blanks
+      s/^ *\/\/.*//; # remove comment lines
+      s/, *\/\/.*/,/; # strip trailing comments
+      next if (/^ *$/); # skip empty lines
+      next unless ($found or $found = /const *tI18nPhrase .*{/); # sync on phrases
+      next if (/const *tI18nPhrase .*{/); # skip sync line
+      last if (/{ *NULL *}/); # stop after last phrase
+      if (/{ *(.*),/) {
+         $Original = $1;
+         $Index = 0;
+         }
+      elsif (/}/) {
+         }
+      else {
+         $Translated = $_;
+         $Translated =~ s/ *(.*),/$1/;
+         $Index++;
+         $Map{$Original}[$Index] = $Translated;
+         }
+      }
+close(F);
+
+# Generate the .pot file:
+
+(mkdir($PODIR) || die "$PODIR: $!\n") unless -d $PODIR;
+
+system("$XGETTEXT -o $POTFILE *.c");
+
+# Generate .po files for all languages:
+
+open(POT, $POTFILE) || die "$POTFILE: $!\n";
+@POT = <POT>;
+close(POT);
+
+for ($Index = 1; $LANGS[$Index]; $Index++) {
+
+    $Authors = "# " . join("\n# ", split(/; */, $TRANSLATORS[$Index])) . "\n";
+
+    $POFILE = "$PODIR/$LANGS[$Index].po";
+    open(PO, ">$POFILE") || die "$POFILE: $!\n";
+    $msgid = "";
+    for (@POT) {
+        next if (/^#, fuzzy$/); # skip the 'fuzzy' keyword
+        $msgid = $1 if (/^msgid (".+")/);
+        $date = $1 if (/POT-Creation-Date: (.*)\\n/);
+        $s = $_;
+        if (!$msgid) {
+           $s =~ s/SOME DESCRIPTIVE TITLE/$TITLE/;
+           $s =~ s/YEAR THE PACKAGE'S COPYRIGHT HOLDER/$COPYRIGHT/;
+           $s =~ s/PACKAGE/$PACKAGE/;
+           $s =~ s/VERSION/$VERSION/;
+           $s = $Authors if (/FIRST AUTHOR/);
+           $s =~ s/YEAR-MO-DA HO:MI\+ZONE/$date/;
+           $s =~ s/FULL NAME <EMAIL\@ADDRESS>/$LASTTRANSLATOR[$Index]/;
+           $s =~ s/LANGUAGE <LL\@li\.org>/$LANGUAGETEAM/;
+           $s =~ s/CHARSET/$CHARSETS[$Index]/;
+           }
+        else {
+           $s =~ s/""/$Map{$msgid}[$Index]/ if ($msgid && /^msgstr ""/ && defined $Map{$msgid}[$Index]);
+           $Used{$msgid} = 1;
+           }
+        print PO $s;
+        }
+    close(PO);
+    }
+
+# Report missing phrases:
+
+for (keys %Map) {
+    push(@Missing, "$_\n") unless $Used{$_};
+    }
+
+if (@Missing) {
+   print "Missing phrases (may need to use trNOOP):\n\n";
+   print sort(@Missing);
+   }
+
+# Adjust the Makefile:
+
+$MAKEI18N = q{### Internationalization (I18N):
+
+PODIR     = po
+LOCALEDIR = $(VDRDIR)/locale
+I18Npo    = $(wildcard $(PODIR)/*.po)
+I18Nmo    = $(addsuffix .mo, $(foreach file, $(I18Npo), $(basename $(file))))
+I18Ndirs  = $(notdir $(foreach file, $(I18Npo), $(basename $(file))))
+I18Npot   = $(PODIR)/$(PLUGIN).pot
+
+%.mo: %.po
+	msgfmt -c -o $@ $<
+
+$(I18Npot): $(wildcard *.c)
+	xgettext -C -cTRANSLATORS --no-wrap -F -k -ktr -ktrNOOP --msgid-bugs-address='<} . $MSGIDBUGS . q{>' -o $@ $(wildcard *.c)
+
+$(I18Npo): $(I18Npot)
+	msgmerge -U --no-wrap -F --backup=none -q $@ $<
+
+i18n: $(I18Nmo)
+	@mkdir -p $(LOCALEDIR)
+	for i in $(I18Ndirs); do\
+	    mkdir -p $(LOCALEDIR)/$$i/LC_MESSAGES;\
+	    cp $(PODIR)/$$i.mo $(LOCALEDIR)/$$i/LC_MESSAGES/$(PLUGIN).mo;\
+	    done
+
+};
+
+open(OLD, "Makefile") || die "Makefile: $!";
+open(NEW, ">Makefile.new") || die "Makefile.new: $!";
+while (<OLD>) {
+      chomp;
+      if (/Targets:/) {
+         print NEW $MAKEI18N;
+         }
+      elsif (/^all:/) {
+         $_ .= " i18n";
+         }
+      elsif (/^clean:/) {
+	 $_ .= "\n\t\@-rm -f \$(PODIR)/*.mo \$(PODIR)/*.pot";
+         }
+      print NEW "$_\n";
+      }
+close(NEW);
+close(OLD);
diff -ruN vdr-1.5.6/i18n.c vdr-1.5.7/i18n.c
--- vdr-1.5.6/i18n.c	2007-07-20 17:04:37.000000000 +0200
+++ vdr-1.5.7/i18n.c	2007-08-12 14:15:29.000000000 +0200
@@ -4,69 +4,12 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: i18n.c 1.302 2007/07/20 15:04:37 kls Exp $
+ * $Id: i18n.c 1.308 2007/08/12 12:15:29 kls Exp $
  *
- * Translations provided by:
- *
- * Slovenian   Miha Setina <mihasetina@softhome.net>, Matjaz Thaler <matjaz.thaler@guest.arnes.si>
- * Italian     Alberto Carraro <bertocar@tin.it>, Antonio Ospite <ospite@studenti.unina.it>, Sean Carlos <seanc@libero.it>, Nino Gerbino <ngerb@interfree.it>
- * Dutch       Arnold Niessen <niessen@iae.nl> <arnold.niessen@philips.com>, Hans Dingemans <hans.dingemans@tacticalops.nl>, Maarten Wisse <Maarten.Wisse@urz.uni-hd.de>
- * Portuguese  Paulo Lopes <pmml@netvita.pt>
- * French      Jean-Claude Repetto <jc@repetto.org>, Olivier Jacques <jacquesolivier@hotmail.com>, Gregoire Favre <greg@magma.unil.ch>, Nicolas Huillard <nhuillard@e-dition.fr>, Pierre Briec <pbriec@free.fr>
- * Norwegian   Jørgen Tvedt <pjtvedt@online.no>, Truls Slevigen <truls@slevigen.no>
- * Finnish     Hannu Savolainen <hannu@opensound.com>, Jaakko Hyvätti <jaakko@hyvatti.iki.fi>, Niko Tarnanen <niko.tarnanen@hut.fi>, Rolf Ahrenberg <rahrenbe@cc.hut.fi>
- * Polish      Michael Rakowski <mrak@gmx.de>, Jaroslaw Swierczynski <swiergot@gmail.com>
- * Spanish     Ruben Nunez Francisco <ruben.nunez@tang-it.com>, Jesus Bravo Alvarez <jba@pobox.com>
- * Greek       Dimitrios Dimitrakos <mail@dimitrios.de>
- * Swedish     Tomas Prybil <tomas@prybil.se>, Jan Ekholm <chakie@infa.abo.fi>
- * Romanian    Paul Lacatus <paul@campina.iiruc.ro>, Lucian Muresan <lucianm@users.sourceforge.net>
- * Hungarian   Istvan & Silvia Koenigsberger <istvnko@hotmail.com>, Guido Josten <guido.josten@t-online.de>
- * Catalanian  Marc Rovira Vall <tm05462@salleURL.edu>, Ramon Roca <ramon.roca@xcombo.com>, Jordi Vilà <jvila@tinet.org>
- * Russian     Vyacheslav Dikonov <sdiconov@mail.ru>, Oleg Roitburd <oleg@roitburd.de>
- * Croatian    Drazen Dupor <drazen.dupor@dupor.com>, Dino Ravnic <dino.ravnic@fer.hr>
- * Estonian    Arthur Konovalov <kasjas@hot.ee>
- * Danish      Mogens Elneff <mogens@elneff.dk>
- * Czech       Vladimír Bárta <vladimir.barta@k2atmitec.cz>
- * Turkish     Oktay Yolgeçen <oktay_73@yahoo.de>
  *
  */
 
 /*
- * How to add a new language:
- *
- * 1. Announce your translation action on the VDR mailing
- *    list to avoid duplicate work.
- * 2. Increase the value of 'I18nNumLanguages' in 'i18n.h'.
- * 3. Insert a new line in every member of the 'Phrases[]' array,
- *    containing the translated text for the new language.
- *    For example, assuming you want to add the Italian language,
- *
- *       { "English",
- *         "Deutsch",
- *       },
- *
- *    would become
- *
- *       { "English",
- *         "Deutsch",
- *         "Italiano",
- *       },
- *
- *    and so on. Append your language after the last existing language
- *    and write the name of your language in your language (not in English,
- *    which means that it should be 'Italiano', not 'Italian').
- *    Note that only the characters defined in 'fontosd.c' will
- *    be available!
- * 4. If your language requires a character set other than the default iso8859-1
- *    you need to make the appropriate entry in the second phrase below, and
- *    also create the necessary font files in case they are not yet part of
- *    the VDR source (see how this is done for iso8859-7, for instance). Don't
- *    forget to adjust the files font.h and font.c accordingly.
- * 5. Compile VDR and test the new language by switching to it
- *    in the "Setup/OSD" menu.
- * 6. Send the modified files to <kls@cadsoft.de> to have
- *    it included in the next version of VDR.
- *
  * In case an English phrase is used in more than one context (and might need
  * different translations in other languages) it can be preceded with an
  * arbitrary string to describe its context, separated from the actual phrase
diff -ruN vdr-1.5.6/i18n.c vdr-1.5.7/i18n.c
--- vdr-1.5.6/i18n.c	2007-07-20 17:04:37.000000000 +0200
+++ vdr-1.5.7/i18n.c	2007-08-12 14:15:29.000000000 +0200
@@ -7096,7 +249,7 @@
   bool found = false;
   while (LanguageCode) {
         int LanguageIndex = I18nLanguageIndex(LanguageCode);
-        for (int i = 0; i < I18nNumLanguages; i++) {
+        for (int i = 0; i < LanguageCodes.Size(); i++) {
             if (PreferredLanguages[i] < 0)
                break; // the language is not a preferred one
             if (PreferredLanguages[i] == LanguageIndex) {
@@ -7117,7 +270,7 @@
            *Position = 0;
         }
   if (OldPreference < 0) {
-     OldPreference = I18nNumLanguages; // higher than the maximum possible value
+     OldPreference = LanguageCodes.Size(); // higher than the maximum possible value
      return true; // if we don't find a preferred one, we take the first one
      }
   return found;
diff -ruN vdr-1.5.6/i18n.h vdr-1.5.7/i18n.h
--- vdr-1.5.6/i18n.h	2007-05-28 13:43:14.000000000 +0200
+++ vdr-1.5.7/i18n.h	2007-08-10 15:53:57.000000000 +0200
@@ -4,25 +4,58 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: i18n.h 1.20 2007/05/28 11:43:14 kls Exp $
+ * $Id: i18n.h 1.21 2007/08/10 13:53:57 kls Exp $
  */
 
 #ifndef __I18N_H
 #define __I18N_H
 
 #include <stdio.h>
+#include "tools.h"
 
-const int I18nNumLanguages = 22;
-
-typedef const char *tI18nPhrase[I18nNumLanguages];
-
-void I18nRegister(const tI18nPhrase * const Phrases, const char *Plugin);
+typedef const char *tI18nPhrase[22]; ///< obsolete - switch to 'gettext'!
 
+#define I18N_DEFAULT_LOCALE "en_US"
+#define I18N_MAX_LOCALE_LEN 16       // for buffers that hold en_US etc.
+#define I18N_MAX_LANGUAGES  256      // for buffers that hold all available languages
+
+void I18nInitialize(void);
+   ///< Detects all available locales and loads the language names and codes.
+void I18nRegister(const char *Plugin);
+   ///< Registers the named plugin, so that it can use internationalized texts.
+void I18nSetLocale(const char *Locale);
+   ///< Sets the current locale to Locale. The default locale is "en_US".
+   ///< If no such locale has been found in the call to I18nInitialize(),
+   ///< nothing happens.
+int I18nCurrentLanguage(void);
+   ///< Returns the index of the current language. This number stays the
+   ///< same for any given language while the program is running, but may
+   ///< be different when the program is run again (for instance because
+   ///< a locale has been added or removed). The default locale ("en_US")
+   ///< always has a zero index.
+void I18nSetLanguage(int Language);
+   ///< Sets the current language index to Language. If Language is outside
+   ///< the range of available languages, nothing happens.
+const cStringList *I18nLanguages(void);
+   ///< Returns the list of available languages. Values returned by
+   ///< I18nCurrentLanguage() are indexes into this list.
 const char *I18nTranslate(const char *s, const char *Plugin = NULL) __attribute_format_arg__(1);
-
-const char * const * I18nLanguages(void);
-const char *I18nLanguageCode(int Index);
+   ///< Translates the given string (with optional Plugin context) into
+   ///< the current language. If no translation is available, the original
+   ///< string will be returned.
+const char *I18nLocale(int Language);
+   ///< Returns the locale code of the given Language (which is an index as
+   ///< returned by I18nCurrentLanguage()). If Language is outside the range
+   ///< of available languages, NULL is returned.
+const char *I18nLanguageCode(int Language);
+   ///< Returns the three letter language code of the given Language (which
+   ///< is an index as returned by I18nCurrentLanguage()). If Language is
+   ///< outside the range of available languages, NULL is returned.
+   ///< The returned string may consist of several alternative three letter
+   ///< language codes, separated by commas (as in "deu,ger").
 int I18nLanguageIndex(const char *Code);
+   ///< Returns the index of the language with the given three letter
+   ///< language Code. If no suitable language is found, -1 is returned.
 const char *I18nNormalizeLanguageCode(const char *Code);
    ///< Returns a 3 letter language code that may not be zero terminated.
    ///< If no normalized language code can be found, the given Code is returned.
@@ -44,4 +77,6 @@
 #define tr(s)  I18nTranslate(s)
 #endif
 
+#define trNOOP(s) (s)
+
 #endif //__I18N_H
diff -ruN vdr-1.5.6/interface.c vdr-1.5.7/interface.c
--- vdr-1.5.6/interface.c	2006-03-31 16:20:04.000000000 +0200
+++ vdr-1.5.7/interface.c	2007-08-04 16:39:25.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: interface.c 1.75 2006/03/31 14:20:04 kls Exp $
+ * $Id: interface.c 1.76 2007/08/04 14:39:25 kls Exp $
  */
 
 #include "interface.h"
@@ -87,9 +87,7 @@
      eKeys NewKey = kUp;
      while (NewKey != kNone) {
            char *Prompt;
-           char buf[32];
-           snprintf(buf, sizeof(buf), "Key$%s", cKey::ToString(NewKey));
-           asprintf(&Prompt, tr("Press key for '%s'"), tr(buf));
+           asprintf(&Prompt, tr("Press key for '%s'"), cKey::ToString(NewKey, true));
            DisplayMenu->SetItem(Prompt, 4, false, false);
            free(Prompt);
            cRemote::Clear();
diff -ruN vdr-1.5.6/keys.c vdr-1.5.7/keys.c
--- vdr-1.5.6/keys.c	2006-10-14 12:18:05.000000000 +0200
+++ vdr-1.5.7/keys.c	2007-08-11 13:30:18.000000000 +0200
@@ -4,69 +4,69 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: keys.c 1.14 2006/10/14 10:18:05 kls Exp $
+ * $Id: keys.c 1.15 2007/08/11 11:30:18 kls Exp $
  */
 
 #include "keys.h"
 #include "plugin.h"
 
 static tKey keyTable[] = { // "Up" and "Down" must be the first two keys!
-                    { kUp,            "Up"         },
-                    { kDown,          "Down"       },
-                    { kMenu,          "Menu"       },
-                    { kOk,            "Ok"         },
-                    { kBack,          "Back"       },
-                    { kLeft,          "Left"       },
-                    { kRight,         "Right"      },
-                    { kRed,           "Red"        },
-                    { kGreen,         "Green"      },
-                    { kYellow,        "Yellow"     },
-                    { kBlue,          "Blue"       },
-                    { k0,             "0"          },
-                    { k1,             "1"          },
-                    { k2,             "2"          },
-                    { k3,             "3"          },
-                    { k4,             "4"          },
-                    { k5,             "5"          },
-                    { k6,             "6"          },
-                    { k7,             "7"          },
-                    { k8,             "8"          },
-                    { k9,             "9"          },
-                    { kInfo,          "Info"       },
-                    { kPlay,          "Play"       },
-                    { kPause,         "Pause"      },
-                    { kStop,          "Stop"       },
-                    { kRecord,        "Record"     },
-                    { kFastFwd,       "FastFwd"    },
-                    { kFastRew,       "FastRew"    },
-                    { kNext,          "Next"       },
-                    { kPrev,          "Prev"       },
-                    { kPower,         "Power"      },
-                    { kChanUp,        "Channel+"   },
-                    { kChanDn,        "Channel-"   },
-                    { kChanPrev,      "PrevChannel"},
-                    { kVolUp,         "Volume+"    },
-                    { kVolDn,         "Volume-"    },
-                    { kMute,          "Mute"       },
-                    { kAudio,         "Audio"      },
-                    { kSchedule,      "Schedule"   },
-                    { kChannels,      "Channels"   },
-                    { kTimers,        "Timers"     },
-                    { kRecordings,    "Recordings" },
-                    { kSetup,         "Setup"      },
-                    { kCommands,      "Commands"   },
-                    { kUser1,         "User1"      },
-                    { kUser2,         "User2"      },
-                    { kUser3,         "User3"      },
-                    { kUser4,         "User4"      },
-                    { kUser5,         "User5"      },
-                    { kUser6,         "User6"      },
-                    { kUser7,         "User7"      },
-                    { kUser8,         "User8"      },
-                    { kUser9,         "User9"      },
-                    { kNone,          ""           },
-                    { k_Setup,        "_Setup"     },
-                    { kNone,          NULL         },
+                    { kUp,            trNOOP("Key$Up")          },
+                    { kDown,          trNOOP("Key$Down")        },
+                    { kMenu,          trNOOP("Key$Menu")        },
+                    { kOk,            trNOOP("Key$Ok")          },
+                    { kBack,          trNOOP("Key$Back")        },
+                    { kLeft,          trNOOP("Key$Left")        },
+                    { kRight,         trNOOP("Key$Right")       },
+                    { kRed,           trNOOP("Key$Red")         },
+                    { kGreen,         trNOOP("Key$Green")       },
+                    { kYellow,        trNOOP("Key$Yellow")      },
+                    { kBlue,          trNOOP("Key$Blue")        },
+                    { k0,                    "0"                },
+                    { k1,                    "1"                },
+                    { k2,                    "2"                },
+                    { k3,                    "3"                },
+                    { k4,                    "4"                },
+                    { k5,                    "5"                },
+                    { k6,                    "6"                },
+                    { k7,                    "7"                },
+                    { k8,                    "8"                },
+                    { k9,                    "9"                },
+                    { kInfo,          trNOOP("Key$Info")        },
+                    { kPlay,          trNOOP("Key$Play")        },
+                    { kPause,         trNOOP("Key$Pause")       },
+                    { kStop,          trNOOP("Key$Stop")        },
+                    { kRecord,        trNOOP("Key$Record")      },
+                    { kFastFwd,       trNOOP("Key$FastFwd")     },
+                    { kFastRew,       trNOOP("Key$FastRew")     },
+                    { kNext,          trNOOP("Key$Next")        },
+                    { kPrev,          trNOOP("Key$Prev")        },
+                    { kPower,         trNOOP("Key$Power")       },
+                    { kChanUp,        trNOOP("Key$Channel+")    },
+                    { kChanDn,        trNOOP("Key$Channel-")    },
+                    { kChanPrev,      trNOOP("Key$PrevChannel") },
+                    { kVolUp,         trNOOP("Key$Volume+")     },
+                    { kVolDn,         trNOOP("Key$Volume-")     },
+                    { kMute,          trNOOP("Key$Mute")        },
+                    { kAudio,         trNOOP("Key$Audio")       },
+                    { kSchedule,      trNOOP("Key$Schedule")    },
+                    { kChannels,      trNOOP("Key$Channels")    },
+                    { kTimers,        trNOOP("Key$Timers")      },
+                    { kRecordings,    trNOOP("Key$Recordings")  },
+                    { kSetup,         trNOOP("Key$Setup")       },
+                    { kCommands,      trNOOP("Key$Commands")    },
+                    { kUser1,         trNOOP("Key$User1")       },
+                    { kUser2,         trNOOP("Key$User2")       },
+                    { kUser3,         trNOOP("Key$User3")       },
+                    { kUser4,         trNOOP("Key$User4")       },
+                    { kUser5,         trNOOP("Key$User5")       },
+                    { kUser6,         trNOOP("Key$User6")       },
+                    { kUser7,         trNOOP("Key$User7")       },
+                    { kUser8,         trNOOP("Key$User8")       },
+                    { kUser9,         trNOOP("Key$User9")       },
+                    { kNone,                 ""                 },
+                    { k_Setup,               "_Setup"           },
+                    { kNone,                 NULL               },
                   };
 
 // -- cKey -------------------------------------------------------------------
@@ -121,18 +121,29 @@
 {
   if (Name) {
      for (tKey *k = keyTable; k->name; k++) {
-         if (strcasecmp(k->name, Name) == 0)
+         const char *n = k->name;
+         const char *p = strchr(n, '$');
+         if (p)
+            n = p + 1;
+         if (strcasecmp(n, Name) == 0)
             return k->type;
          }
      }
   return kNone;
 }
 
-const char *cKey::ToString(eKeys Key)
+const char *cKey::ToString(eKeys Key, bool Translate)
 {
   for (tKey *k = keyTable; k->name; k++) {
-      if (k->type == Key)
-         return k->name;
+      if (k->type == Key) {
+         const char *n = k->name;
+         if (Translate)
+            n = tr(n);
+         const char *p = strchr(n, '$');
+         if (p)
+            n = p + 1;
+         return n;
+         }
       }
   return NULL;
 }
diff -ruN vdr-1.5.6/keys.h vdr-1.5.7/keys.h
--- vdr-1.5.6/keys.h	2007-02-25 11:49:35.000000000 +0100
+++ vdr-1.5.7/keys.h	2007-08-04 16:40:23.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: keys.h 1.11 2007/02/25 10:49:35 kls Exp $
+ * $Id: keys.h 1.12 2007/08/04 14:40:23 kls Exp $
  */
 
 #ifndef __KEYS_H
@@ -100,7 +100,7 @@
   bool Parse(char *s);
   bool Save(FILE *f);
   static eKeys FromString(const char *Name);
-  static const char *ToString(eKeys Key);
+  static const char *ToString(eKeys Key, bool Translate = false);
   };
 
 class cKeys : public cConfig<cKey> {
